%macro addhstry (action_type_id=,
                 solution_id=,
                 object_type_id=,
                 object_id_table=,
                 object_id_column_nm=,
                 bldlibnm_sassdm=Y,
                 OMRMartLibraryObjName=,
                 martLibRef=_SDMLIB
                );

%if &action_type_id=%str() %then %do;
  %put action_type_id parameter is empty.  Aborting addhstry(). ;
  %return ;
%end ;

%if &solution_id=%str() %then %do;
  %put solution_id parameter is empty.  Aborting addhstry(). ;
  %return ;
%end ;

%if &object_type_id=%str() %then %do;
  %put object_type_id parameter is empty.  Aborting addhstry(). ;
  %return ;
%end ;

%if &object_id_table=%str() %then %do;
  %put object_id_table parameter is empty.  Aborting addhstry(). ;
  %return ;
%end ;

%if &object_id_column_nm=%str() %then %do;
  %put object_id_column_nm parameter is empty.  Aborting addhstry(). ;
  %return ;
%end ;

%if %sysfunc( exist(&object_id_table) ) eq 0 %then %return ;

%if &bldlibnm_sassdm = Y %then %do ;

    %bldLibNm(sesetl_sasLibRef=_SDMLIB
            , sesetl_OMRSASLibraryObjName=&Solsystem_folder/&SdmLibObj./&SdmLibObj.
            , sesetl_useType=BASE,
              sesetl_validateLib=Y
             ) ;

    %bldLibNm(sesetl_OMRSASLibraryObjName=&Solsystem_folder/&SdmLibObj./&SdmLibObj.,
              sesetl_useType=CON
              ) ;

%end ;

proc sql noprint;
  select count(*) INTO :fmsetl_auditCnt from &object_id_table ;
quit;
%if &fmsetl_auditCnt = 0 %then %do;
  %put &object_id_table is empty.  No audit record(s) to update. ;
  %return ;
%end ;

%let fmsetl_auditObjTypeCd = ses/audit ;
%let fmsetl_nextAvailKey = 0 ;

proc sql noprint;
  select KEY_CNT into :fmsetl_nextAvailKey from _SDMLIB.SAS_KEYGEN
      where IDENTIFIER_CD = "&fmsetl_auditObjTypeCd";
quit;

%if (&fmsetl_nextAvailKey EQ 0) %then
   %let fmsetl_nextAvailKey = 1 ;

%let fmsetl_newKey = &fmsetl_auditCnt + &fmsetl_nextAvailKey;

/* %sesskey(keyCode=%str(&fmsetl_auditObjTypeCd), keyNext=&fmsetl_newKey) ; */
%sesskey(keyCode=%str(ses/audit), keyNext=&fmsetl_newKey) ;

%let fmsetl_timestamp = 0 ;

proc sql noprint;
  connect to &sesetl_EngineType ( &sesetl_BestLogin &sesetl_ConnectionOptions );
  execute(create table a as select extract(EPOCH from current_timestamp(0))) by &sesetl_EngineType;
  execute(alter table a add gmt_timestamp varchar(50)) by &sesetl_EngineType;
  execute(update a set gmt_timestamp = extract(EPOCH from current_timestamp(0))) by &sesetl_EngineType;
  disconnect from &sesetl_EngineType;
quit;

proc sql noprint;
  select gmt_timestamp into :timestamp_secs from _SDMLIB.a;
quit;

proc sql noprint;
  connect to &sesetl_EngineType ( &sesetl_BestLogin &sesetl_ConnectionOptions );
  execute(drop table a) by &sesetl_EngineType;
  disconnect from &sesetl_EngineType;
quit;

data _null_ ;
  ts = &timestamp_secs * 1000 ;
  call symput('fmsetl_timestamp', strip(put(ts, 32.))) ;
run ;

data work._newaudit ;
  keep AUDIT_ID
       TIMESTAMP_TS
       USERNAME
       ACTION_TYPE_ID
       OBJECT_ID
       TRANSACTION_ID
       OBJECT_CLASS_ID
       SOLUTION_ID
       COMMENT_ID
       HAS_AUDIT_ENTRIES
       SESSION_ID
       AUDIT_INFO
       ;

  set _SDMLIB.SAS_AUDIT(obs=0)
      &object_id_table ;

  AUDIT_ID = (&fmsetl_nextAvailKey + _n_ - 1) ;
  TIMESTAMP_TS = &fmsetl_timestamp ;
  USERNAME = "sasadm" ;
  ACTION_TYPE_ID = &action_type_id ;
  if (&object_type_id = 2009) then
     OBJECT_ID = strip(put(INTERNAL_DIMENSION_ID, 32.)) || ',' || strip(put(&object_id_column_nm, 32.));
  else
     OBJECT_ID = strip(put(&object_id_column_nm, 32.));

  TRANSACTION_ID = -1 ;
  OBJECT_CLASS_ID = &object_type_id ;
  SOLUTION_ID = &solution_id ;
  HAS_AUDIT_ENTRIES = '0';
run ;

proc append base=_SDMLIB.SAS_AUDIT data=work._newaudit &FM_PROCAPPENDFORCE;
run ;

%mend ;
