%macro cpmload(output_dataset_name=);

  option validvarname=ANY;

  %let cSDMLib = _SDMLIB;

  %startsln(FMS);

  %bldLibNm(sesetl_sasLibRef=&cSDMLib
          , sesetl_OMRSASLibraryObjName=&Solsystem_folder./&SdmLibObj./&SdmLibObj.
          , sesetl_useType=BASE
          , sesetl_validateLib=Y
           ) ;

  %bldLibNm(sesetl_OMRSASLibraryObjName=&Solsystem_folder./&SdmLibObj./&SdmLibObj.
          , sesetl_useType=CON
           ) ;

  /***************************************************************************************/
  /* Validation for the existence of global macro variables and their values.            */
  /***************************************************************************************/

  %if %symexist(fmsetl_tempStatusTable) %then %do;
     %if %nrbquote(&fmsetl_tempStatusTable) = %str() %then %do;
        %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                 msgTxt1=<fmsetl_tempStatusTable : &fmsetl_tempStatusTable>,
                 msgPutlog=&putlog);
        %let fmsetl_errorId=1;
        endsas;
     %end;
  %end;
  %else %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
              msgTxt1=<fmsetl_tempStatusTable>, msgPutlog=&putlog);
     %let fmsetl_errorId=2;
     endsas;
  %end;

  %if %symexist(fmsetl_actionType) %then %do;
     %if %nrbquote(&fmsetl_actionType) = %str() %then %do;
        %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                 msgTxt1=<fmsetl_actionType : &fmsetl_actionType>,
                 msgPutlog=&putlog);
        %let fmsetl_errorId=1;
        endsas;
     %end;
  %end;
  %else %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
              msgTxt1=<fmsetl_actionType>, msgPutlog=&putlog);
     %let fmsetl_errorId=2;
     endsas;
  %end;

  %if %symexist(fmsetl_dataLoadObjectTypeId) %then %do;
     %if %nrbquote(&fmsetl_dataLoadObjectTypeId) = %str() %then %do;
        %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                 msgTxt1=<fmsetl_dataLoadObjectTypeId : &fmsetl_dataLoadObjectTypeId>,
                 msgPutlog=&putlog);
        %let fmsetl_errorId=1;
        endsas;
     %end;
  %end;
  %else %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
              msgTxt1=<fmsetl_dataLoadObjectTypeId>, msgPutlog=&putlog);
     %let fmsetl_errorId=2;
     endsas;
  %end;

  %if %symexist(fmsetl_dataLoadObjectIds) %then %do;
     %if %nrbquote(&fmsetl_dataLoadObjectIds) = %str() %then %do;
        %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                 msgTxt1=<fmsetl_dataLoadObjectIds : &fmsetl_dataLoadObjectIds>,
                 msgPutlog=&putlog);
        %let fmsetl_errorId=1;
        endsas;
     %end;
  %end;
  %else %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
              msgTxt1=<fmsetl_dataLoadObjectIds>, msgPutlog=&putlog);
     %let fmsetl_errorId=2;
     endsas;
  %end;

  %if %symexist(fmsetl_instanceId) %then %do;
     %if %nrbquote(&fmsetl_instanceId) = %str() %then %do;
        %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                 msgTxt1=<fmsetl_instanceId : &fmsetl_instanceId>,
                 msgPutlog=&putlog);
        %let fmsetl_errorId=1;
        endsas;
     %end;
  %end;
  %else %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
              msgTxt1=<fmsetl_instanceId>, msgPutlog=&putlog);
     %let fmsetl_errorId=2;
     endsas;
  %end;

  %if %symexist(fmsetl_tempCreateFactTable) %then %do;
     %if %nrbquote(&fmsetl_tempCreateFactTable) = %str() %then %do;
        %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                 msgTxt1=<fmsetl_tempCreateFactTable : &fmsetl_tempCreateFactTable>,
                 msgPutlog=&putlog);
        %let fmsetl_errorId=1;
        endsas;
     %end;
  %end;
  %else %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
              msgTxt1=<fmsetl_tempCreateFactTable>, msgPutlog=&putlog);
     %let fmsetl_errorId=2;
     endsas;
  %end;

  /****************************************************************************************/
  /* This macro will load the data generated by the custom written optimization code into */
  /* the SDM.                                                                             */
  /****************************************************************************************/

  %let cSDMStatusDS               = &fmsetl_tempStatusTable;
  %let nActionType                = &fmsetl_actionType;
  %let cDLObjTypeId               = &fmsetl_dataLoadObjectTypeId;
  %let cETL_instanceID            = &fmsetl_instanceId;
  %let cTmpFactSDM_Nm             = &fmsetl_tempCreateFactTable;

    /*  Assign constants  */
  %let cStatusDS                  = work._factstatus;
  %let cTmpFactWork_Nm            = work.sas_etl_base_fact;

  %global lcycledimtypes;
  %let lcycledimtypes             = work.cycleDTypes;

  /***************************************************************************************/

  proc sql noprint;
     select count(*) into :factCnt from &output_dataset_name;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  %mbrConcat(&lcycledimtypes) ;

  %DimDimTypeFormats;

  %createHashTable;

  proc sql noprint;
    ALTER TABLE &output_dataset_name
    DROP COLUMN FREQUENCY_CODE;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  %createUpdateTable(input_table_name=&output_dataset_name,
                     bfdtypes=&cBfDtypes,
                     dataLoadObjTypeId=&fmsetl_dataLoadObjectTypeId,
                     dataLoadObjId=&fmsetl_dataLoadObjectIds,
                     update_tablename=&cTmpFactWork_Nm);

  /********************************************************************************
   *
   *  Gather some stats on the outcome of the job, to send back to calling code
   *
   ********************************************************************************/

  /*  Create a table of all Successful imports */
  %cpm_buildStatusDS(&cStatusDS, 0);

  /*  Count successful Imports  */
  %cpm_updateValidStatusCnt( &cStatusDS, &cTmpFactWork_Nm, IMPORTED_TRANS_CNT );

  /*  Count Zero values  */
  %cpm_updateZeroStatusCnt( &cStatusDS, &cTmpFactWork_Nm, ZERO_TRANS_CNT);

  %if &nActionType NE 4 and &nActionType NE 5 %then
     %cpm_uploadTempFactToSDM(&lcycledimtypes, &cTmpFactSDM_Nm, &cTmpFactWork_Nm, &cStatusDS );
  %else
     %cpm_replaceMatching(&cStatusDS, &nActionType, &lcycledimtypes, &cSdmLib, &cDLObjTypeId, &cTmpFactWork_Nm,
                           &cTmpFactSDM_Nm, &cETL_instanceID);

  /*  Upload Status Report to SASSDM  */
  %cpm_uploadStatusTableToSDM(&cStatusDS, &cSDMStatusDS);

  %let fmsetl_statusId=0;  /* success=0, critical error=1, validation error=2, warning=3 */

  %RETURNZERO:

%mend cpmload;

/***************************************************************************************/
%macro mbrConcat(lDTypes);

  /************************/
  /*  FMT_DTYPE_ID_TO_CD  */
  /************************/

  %let _tmpDSN = &cSDMLib..sas_dim_type;
  %let _tmpFormat = fmt_dtype_id_to_cd;
  %let _tmpStart = dim_type_id;
  %let _tmpLabel = dim_type_cd;

  proc sort data = &_tmpDSN(where=(valid_from_dttm <= &today_dttm_val and
                            valid_to_dttm >= &today_dttm_val))
             out = work._tmpsort(drop = valid_from_dttm valid_to_dttm)
             nodupkey;
     by &_tmpStart;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  data work.&_tmpFormat;
     retain fmtname "&_tmpFormat";
     retain type "N";
     set work._tmpsort;
     start = &_tmpStart;
     label = &_tmpLabel;
     keep start label fmtname type;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc format cntlin=work.&_tmpFormat library=work;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  %if not %sysfunc( cexist(work.formats.&_tmpFormat..format) ) %then %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=3,
              msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
     %let fmsetl_errorId = 3;
     endsas;
  %end;

/***************************************************************************************/
  proc sql noprint;
      create table work.factSet_dtype_ids as select dim_type_id, ordinal
         from &cSDMLib..sas_fact_set_dim_type
         where fact_set_id = &fmsetl_fact_set_id ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  data &lDTypes;
     length code $ %eval(32*&FM_DBCSMULT);
     length ordinal 8;
     set work.factSet_dtype_ids;
     code = put(dim_type_id, fmt_dtype_id_to_cd.);
     keep ordinal code dim_type_id;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc sort data = &lDTypes;
    by ordinal;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  %global dimcnt;
  %global dtype_ids;
  %global cBfDtypes;
  %global tmp_keep_dtypes;

  %let dimcnt= ;
  %let dtype_id= ;
  %let cBfDtypes= ;
  %let tmp_keep_dtypes= ;

  proc sql noprint;
     select count(*) into :dimcnt from &lDTypes;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  data _null_ ;
     set &lDTypes end=nEnd ;
     if _n_ = 1 then do ;
        call symput("tmp_keep_dtypes",'"'||kstrip(code)||'"n');
        call symput("cBfDtypes",kstrip(code));
     end ;
     else do ;
        call symput("tmp_keep_dtypes",kstrip(symget("tmp_keep_dtypes"))||' "'||kstrip(code)||'"n');
        call symput("cBfDtypes",kstrip(symget("cBfDtypes"))||'|'||kstrip(code));
     end ;
  run ;
  %checkErr;
  %if &_tmpRC %then endsas;

%mend mbrConcat;

/***************************************************************************************/
/* Create formats needed for deriving the internal dimension id for each dimension     */
/* type of the temporary fact table.                                                   */
/***************************************************************************************/
%macro DimDimTypeFormats;

  proc sql noprint;
    create table work._tmpalldims as
    select dimension_cd, internal_dimension_id, dim_type_id from &cSDMLib..sas_dimension
      where dimension_id in (select dimension_id from &cSDMLib..sas_vcube_hierarchy where vcube_id in
           (select vcube_id from &cSDMLib..sas_vcube where vcube_cd = "&model_code"));

  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  %let _tmpSortVar = dim_type_id;
  proc sort data = work._tmpalldims;
     by &_tmpSortVar;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  %let _tmpWhere = where=(valid_from_dttm <= &today_dttm_val and
                          valid_to_dttm >= &today_dttm_val);

  data work._tmpsdmdimtype;
     set &cSDMLib..sas_dim_type (&_tmpWhere);
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc sort data = work._tmpsdmdimtype;
     by &_tmpSortVar;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  data work._tmpalldims;
     merge work._tmpalldims (in = inA)
           work._tmpsdmdimtype;
        by &_tmpSortVar;
     keep dimension_cd internal_dimension_id dim_type_id dim_type_cd;
     if (inA) then
        output;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  /* FMT_TO_DIM */

  %let _tmpDSN=WORK._TMPALLDIMS;
  %let _tmpFormat=FMT_TO_DIM;
  %let _tmpStart=DIM_TYPE_CD;
  %let _tmpLabel=DIMENSION_CD;
  data WORK.&_tmpFormat;
     retain FMTNAME "&_tmpFormat";
     retain TYPE "C";
     retain HLO "";
     set &_tmpDSN;
     START = &_tmpStart;
     LABEL = &_tmpLabel;
     keep START LABEL FMTNAME TYPE HLO;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc format cntlin=&_tmpFormat library=WORK;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  %if not %sysfunc( cexist(work.formats.&_tmpFormat..formatc) ) %then %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=3,
              msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
     %let fmsetl_errorId = 3;
     endsas;
  %end;

  /* FMT_DIMS */

  %let _tmpDSN=WORK._TMPALLDIMS;
  %let _tmpFormat=FMT_DIMS;
  %let _tmpStart=DIM_TYPE_ID;
  %let _tmpLabel=INTERNAL_DIMENSION_ID;

  data work.&_tmpFormat;
     retain FMTNAME "&_tmpFormat";
     retain TYPE "I";
     retain HLO "";
     set &_tmpDSN;
     START = &_tmpStart;
     LABEL = &_tmpLabel;
     keep START LABEL FMTNAME TYPE HLO;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc format cntlin=&_tmpFormat library=WORK;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  %if not %sysfunc( cexist(work.formats.&_tmpFormat..infmt) ) %then %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=3,
              msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
     %let fmsetl_errorId = 3;
     endsas;
  %end;

  /* FMT_DTYPE_ID */

  %let _tmpDSN=WORK._TMPALLDIMS;
  %let _tmpFormat=FMT_DTYPE_ID;
  %let _tmpStart=DIMENSION_CD;
  %let _tmpLabel=DIM_TYPE_ID;

  data work.&_tmpFormat;
     retain FMTNAME "&_tmpFormat";
     retain TYPE "I";
     retain HLO "";
     set &_tmpDSN;
     START = &_tmpStart;
     LABEL = &_tmpLabel;
     keep START LABEL FMTNAME TYPE HLO;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc format cntlin=&_tmpFormat library=WORK;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  %if not %sysfunc( cexist(work.formats.&_tmpFormat..infmt) ) %then %do;
     %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=3,
              msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
     %let fmsetl_errorId = 3;
     endsas;
  %end;

%mend DimDimTypeFormats;

/******************************************************************************************/
/* Creation of hash table to derive a member_id from the internal dimension id and member */
/* code.                                                                                  */
/******************************************************************************************/
%macro createHashTable;

  %let _tmpDSN=&cSDMLib..sas_member;

  proc sql noprint;
    create table work.memberHashTable as select internal_dimension_id, member_cd, member_id
       from &_tmpDSN
       where internal_dimension_id in (select internal_dimension_id from work._tmpalldims) and
             valid_from_dttm <= &today_dttm_val and valid_to_dttm >= &today_dttm_val;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

%mend createHashTable;

/***************************************************************************************/
%macro createUpdateTable(input_table_name=, bfdtypes=, dataLoadObjTypeId=,
                         dataLoadObjId=, update_tablename= );

  %macro datawork/parmbuff;

    %let code=_CODE;

    %let _tmpMissingCdErr = 0;

    %if %symexist(cpmdbug) and %symexist(dbuglib) %then %do;
       %if &cpmdbug = 1 %then %do;
          data &dbuglib..load_input;
             set &input_table_name;
          run;
          %checkErr;
          %if &_tmpRC %then endsas;
       %end;
    %end;

    data &update_tablename;
       length OBJECT_TYPE_ID 8 ;
       length OBJECT_ID 8 ;
       length &tmp_keep_dtypes vc_found numchar startpos 8;
       length dimension_cd $ %eval(32*&FM_DBCSMULT);
       length member_cd $ %eval(32*&FM_DBCSMULT);
     length strcheck $ 3;
       set &input_table_name;

       if _n_ = 1 then do;
          declare hash mht(dataset:"work.memberHashTable");
          mht.defineKey("internal_dimension_id", "member_cd");
          mht.defineData("member_id");
          mht.defineDone();
       end;

       OBJECT_TYPE_ID = &dataLoadObjTypeId ;
       OBJECT_ID = &dataLoadObjId;
       %let dtypeString=%sysfunc(ksubstr(&syspbuff, 2), %eval(%sysfunc(klength(&syspbuff)) -2 ));
       %do i = 1 %to &dimcnt;
           %let dimtype=%sysfunc(kscan(%bquote(&dtypeString),&i,|));
           %let dimname=%bquote(%sysfunc(putc(&dimtype, $FMT_TO_DIM.)));
           %let dimtype_id=%sysfunc(inputn(&dimname, FMT_DTYPE_ID.));
           %let int_dim_id=%sysfunc(inputn(&dimtype_id, FMT_DIMS.));
           %let dimtypecd=%sysfunc(kstrip(&dimtype))&code;
           dimension_cd = "&dimname";
           internal_dimension_id = &int_dim_id;
           member_cd = "&dimtypecd"n;
           vc_found = 0;
           if kindex(member_cd,'.vc') > 0 then do;
          numchar = klength(member_cd);
        startpos = numchar - 2;
        strcheck = ksubstr(member_cd, startpos, 3);
              if strcheck = '.vc' then do;
                 numchar = numchar - 3;
                 member_cd = ksubstr(member_cd, 1, numchar);
                 vc_found = 1;
              end;
           end;
           rc = mht.find();
           if rc = 0 then do;
              if vc_found = 1 then
                 member_id = member_id * (-1);
              "&dimtype"n = member_id;
           end;
           else do;
              call symput("_tmpMissingCdErr", 1);
              call symput("_tmpMem", kstrip(member_cd));
              call symput("_tmpDim", kstrip(dimension_cd));
              stop;
           end;
       %end;
       length FACT_VALUE 8;
       keep OBJECT_TYPE_ID OBJECT_ID &tmp_keep_dtypes FACT_VALUE;
    run;
    %checkErr;
    %if &_tmpRC %then endsas;

    %if &_tmpMissingCdErr %then %do;
        %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=4,
                 msgTxt1=<&_tmpMem>, msgTxt2=<&_tmpDim>, msgPutlog=&putlog);
        %let fmsetl_errorId = 4;
        endsas;
    %end;

  %mend datawork;

  %datawork(&bfdtypes);

%mend createUpdateTable;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_buildStatusDS.sas                                                    */
/*  Purpose: Build a temporary data set to hold status of this import.                 */
/***************************************************************************************/
%macro cpm_buildStatusDS(cStatusDS, statusOverride);

  %let cMethodNm = cpm_buildStatusDS;
  %let cTempStatusDS = WORK._FMSETLTEMP01;
  %let nowDTTM = %qsysfunc(datetime()) ;
  %let nTrackTime = %qsysfunc(datetime()) ;

  %if %sysfunc(exist(&cStatusDS)) %then  %do;
    proc datasets library=work nolist;
      delete %kscan(&cStatusDS, 2, '.');
    quit;
    %checkErr;
    %if &_tmpRC %then endsas;
  %end;

  %if %sysfunc(exist(&cTempStatusDS)) %then  %do;
    proc datasets library=work nolist;
      delete %kscan(&cTempStatusDS, 2, '.');
    quit;
    %checkErr;
    %if &_tmpRC %then endsas;
  %end;

  data &cTempStatusDS(keep=TIME_ID ANALYSIS_ID PERIOD_ID STATUS_ID
                           IMPORTED_TRANS_CNT ZERO_TRANS_CNT INVALID_ERROR_CNT
                           REMOVE_CNT) ;
     length TIME_ID 8;
     length ANALYSIS_ID 8;
     length PERIOD_ID 8;
     TIME_ID = -999999;
     ANALYSIS_ID = -999999;
     PERIOD_ID = -999999;
     STATUS_ID = &statusOverride;
     IMPORTED_TRANS_CNT = 0 ;
     ZERO_TRANS_CNT = 0 ;
     INVALID_ERROR_CNT = 0 ;
     REMOVE_CNT = 0 ;
  run ;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc append base=&cStatusDS data=&cTempStatusDS &FM_PROCAPPENDFORCE;
  run ;
  %checkErr;
  %if &_tmpRC %then endsas;

%mend cpm_buildStatusDS;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_updateValidStatusCnt.sas                                             */
/*  Purpose: Update Valid Status Count.                                                */
/***************************************************************************************/

%macro cpm_updateValidStatusCnt(cStatusDS, cValidDS, cImpCntColNm);

  %let cMethodNm = cpm_updateValidStatusCnt;
  %let cSummaryDS = work._tempFact1;
  %let nowDTTM = %qsysfunc(datetime());
  %let nTrackTime = %qsysfunc(datetime());

  %if %sysfunc(exist(&cSummaryDS)) %then  %do;
    proc datasets library=work nolist;
      delete %kscan(&cSummaryDS, 2, '.');
    quit;
    %checkErr;
    %if &_tmpRC %then endsas;
  %end;

  %let _nobs = 0;
  proc sql noprint;
    select count(*) into :_nobs
    from &cValidDS
    ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc sql noprint;
    update &cStatusDS
    set &cImpCntColNm =
       case when status_id ne 0
         then 0
         else &_nobs
       end
     , status_id =
       case when status_id eq 0 and &_nobs eq 0
         then 3
         else status_id
       end
    ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

%mend cpm_updateValidStatusCnt;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_updateZeroStatusCnt.sas                                              */
/*  Purpose: Update Zero Status Count.                                                 */
/***************************************************************************************/

%macro cpm_updateZeroStatusCnt(cStatusDS, cValidDS, cImpCntColNm);

  %let cMethodNm = cpm_updateZeroStatusCnt;
  %let cSummaryDS = WORK._TEMPFACT1;
  %let nowDTTM = %qsysfunc(datetime());
  %let nTrackTime = %qsysfunc(datetime());

  %if %sysfunc(exist(&cSummaryDS)) %then  %do;
    proc datasets library=work nolist;
      delete %kscan(&cSummaryDS, 2, '.');
    quit;
    %checkErr;
    %if &_tmpRC %then endsas;
  %end;

  %let _nobs = 0;
  proc sql noprint;
    select count(*) into :_nobs
    from &cValidDS
    where FACT_VALUE eq 0
    ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc sql noprint;
    update &cStatusDS
    set &cImpCntColNm =
       case when status_id eq 2
         then 0
         else &_nobs
       end
     , status_id =
       case when status_id ne 2 and &_nobs gt 0 and IMPORTED_TRANS_CNT = 0
         then 0
         else status_id
       end
    ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

%mend cpm_updateZeroStatusCnt;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_uploadTempFactToSDM.sas                                              */
/*  Purpose: Upload Temporary Fact Table to SDM.                                       */
/***************************************************************************************/
%macro cpm_uploadTempFactToSDM (lDTypes, cTmpFactSDM_Nm, cTmpFactWork_Nm, cStatusDS);

  %let cMethodNm = cpm_uploadTempFactToSDM;
  %let nowDTTM = %qsysfunc(datetime());
  %let nTrackTime = %qsysfunc(datetime());

  /*  Get the list of Time and Analysis Ids that have okay import status   */

  proc sql noprint;
    select count(*)
      into :num_data
      from &cStatusDS
      where STATUS_ID = 0;
  quit;

  %let num_data = %eval(&num_data);

  %if &num_data > 0 %then %do;
      /* Find the location of SOURCE and CURRENCY dimension types */
      %let ord_source=;
      %let ord_currency=;

      data _null_;
          set &lDTypes end=IsLast;
          if code='SOURCE' or code='source' then do;
              call symput('ord_source', _N_-1);
          end;
          if code='CURRENCY' or code = 'currency' then do;
              call symput('ord_currency', _N_-1);
          end;
          if IsLast = 1 then
              call symput('num_dim_type', _N_);
      run;

      %let dim_col_def=;  /* List of dimension type column definition in DDL */
      %let dim_col=;      /* List of dimension type column names             */

      %do i=0 %to &num_dim_type-1;
        %if &i = 0 %then %do;
            %let dim_col_def=DIM_&i._MEM_ID integer;
            %if &i ^= &ord_source & &i ^= &ord_currency %then %do;
                 %let dim_col=DIM_&i._MEM_ID;
            %end;
        %end;
        %else %do;
            %let dim_col_def=&dim_col_def,DIM_&i._MEM_ID integer;
             %if &i ^= &ord_source & &i ^= &ord_currency  %then %do;
                %if "&dim_col" = "" %then %do;
                    %let dim_col=DIM_&i._MEM_ID;
                %end;
                %else %do;
                    %let dim_col=&dim_col, DIM_&i._MEM_ID;
                %end;
             %end;
        %end;
      %end;

      data &cTmpFactWork_Nm (/*drop=TIME ANALYSIS INTORG IDXCNT*/);
          length OBJECT_TYPE_ID 8 ;
          length OBJECT_ID 8 ;
          set &cTmpFactWork_Nm;
          length FACT_VALUE 8 ;
      run ;
      %checkErr;
      %if &_tmpRC %then endsas;

      /*------------------------------------------------------------------------*/
      /* Decide the storage type of a temp fact table to be created in SASSDM */
      /*------------------------------------------------------------------------*/
      %let stg_type_tmp=myisam;

      /*-----------------------------------------*/
      /* Move ETL base fact from SAS into SASSDM */
      /*-----------------------------------------*/
      %let tmpUploadNm = PUBLIC.%kscan(&cTmpFactSDM_Nm, 2);

      proc sql noprint;
           connect to &sesetl_EngineType as PASSTHRU ( &sesetl_BestLogin &sesetl_ConnectionOptions );

           execute (DROP TABLE IF EXISTS &tmpUploadNm
           ) by PASSTHRU;

           execute(CREATE TABLE &tmpUploadNm (
                     OBJECT_TYPE_ID INTEGER NOT NULL default 0
                   , OBJECT_ID INTEGER NOT NULL default 0
                   , &dim_col_def
                   , FACT_VALUE DOUBLE PRECISION  NOT NULL default 0
                   )
             ) by PASSTHRU ;

           disconnect from PASSTHRU ;
      quit;
      %checkErr;
      %if &_tmpRC %then endsas;

      %cpm_uploadDataToSDM(&cTmpFactWork_Nm, &tmpUploadNm);

  %end;

%mend cpm_uploadTempFactToSDM;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_uploadDataToSDM.sas                                                  */
/*  Purpose: Upload Table to SDM.                                                      */
/***************************************************************************************/
%macro cpm_uploadDataToSDM(cSrcNm, cTrgNm);

  %let cMethodNm = cpm_uploadDataToSDM;
  %let nTrackTime = %qsysfunc(datetime());

  %let fmsetl_tempCheck1 = ;
  proc sql noprint ;
       select count(*)
         into :fmsetl_tempCheck1
         from &cSrcNm ;
  quit ;
  %checkErr;
  %if &_tmpRC %then endsas;

  %let nCnt = &fmsetl_tempCheck1;
  %if &nCnt eq . %then %let nCnt = 0 ;
  %if &nCnt EQ 0 %then %do;
      /*  No records found, skip the rest  */
    %goto THEEND;
  %end ;

  /*  Create output file name  */
  %let cExportCSV = %qsysfunc(strip(%qsysfunc(tranwrd(%qsysfunc(pathname(SASDATA)), \, /))))/upload%sysfunc(kcompress(%sysfunc( datetime() ), .)).txt;

  /* %let cSrcNm=%qsysfunc(&cSrcNm); */
  filename _outfile "&cExportCSV" encoding='utf-8';
  proc export data=&cSrcNm 
       outfile = _outfile
       dbms = DLM REPLACE;
       delimiter='~';
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc sql noprint;
       connect to &sesetl_EngineType ( &sesetl_BestLogin &sesetl_ConnectionOptions );

       execute( copy &cTrgNm
                from %str(%')&cExportCSV.%str(%')
                with (format csv,
                      delimiter '~',
                      header)
              ) by &sesetl_EngineType ;

       disconnect from &sesetl_EngineType ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  /*  Delete text file  */
  data _null_;
    length fref $8;
    fref = _blank_;
    rc = filename(fref, "&cExportCSV" );

    if rc=0 and fexist(fref) then
      rc=fdelete(fref) ;

    rc=filename(fref, '') ;
  run;

  %THEEND:

%mend cpm_uploadDataToSDM;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_replaceMatching.sas                                                  */
/*  Purpose: Replace matching process.                                                 */
/***************************************************************************************/
%macro cpm_replaceMatching(cStatusDS,
                            nActionType,
                            lDTypes,
                            cSdmLib,
                            cDLObjTypeId,
                            cSASFactsDS,
                            cSDMFactsDB,
                            cETL_instanceID);

%let cMethodNm = cpm_replaceMatching;

%let cSDMFactsDB_NEW=/*PUBLIC.*/ %kscan(&cSDMFactsDB, 2);
%let cTmpROFactSDM_Nm=/*PUBLIC.*/ %kscan(&cTmpROFactSDM_Nm, 2);
%let cTmpRWFactSDM_Nm=/*PUBLIC.*/ %kscan(&cTmpRWFactSDM_Nm, 2);

%let cSASFactsDS_NEW=&cSASFactsDS;

/* Initial assignment. It is changed depending on nActionType */
%let cTmp_ETL_BASE    =  _etl_sas_fact_base_&cETL_instanceID;
%let cTmp_ETL_NO_BASE =  _etl_sas_fact_no_base_&cETL_instanceID;

%let cTmp_RO_BASE    = _sas_fact_ro_base_&cETL_instanceID;
%let cTmp_RW_BASE    = _sas_fact_rw_base_&cETL_instanceID;
%let cTmp_RO_NO_BASE = _sas_fact_ro_no_base_&cETL_instanceID;
%let cTmp_RW_NO_BASE = _sas_fact_rw_no_base_&cETL_instanceID;

%let nowDTTM = %qsysfunc(datetime());
%let nTrackTime = %qsysfunc(datetime());

/*  If this is not a Replace Matching action, return , nActionType should be 4 or 5 */
%if &nActionType NE 4 and &nActionType NE 5 %then %do;
  %goto THEEND;
%end;

/* Find the location of SOURCE, and CURRENCY dimension types */
%let ord_source=;
%let ord_currency=;

data _null_;
    set &lDTypes end=IsLast;
    if upcase(code)='SOURCE' then do;
        call symput('ord_source', _N_-1);
    end;
    if upcase(code)='CURRENCY' then do;
        call symput('ord_currency', _N_-1);
    end;
    if IsLast = 1 then
        call symput('num_dim_type', _N_);
run;
%checkErr;
%if &_tmpRC %then endsas;

%let dim_col_def=;  /* List of dimension type column definition in DDL */
%let dim_col=;      /* List of dimension type column names             */
%let idx_cols=0;    /* Number of columns to be included as part of the index.  Limit of 16 */

%do i=0 %to &num_dim_type-1;
    %if &i = 0 %then %do;
        %let dim_col_def=DIM_&i._MEM_ID integer;
        %if &i ^= &ord_source & &i ^= &ord_currency %then %do;
              %let dim_col=DIM_&i._MEM_ID;
              %let idx_cols = %eval(&idx_cols + 1);
        %end;
    %end;
    %else %do;
        %let dim_col_def=&dim_col_def,DIM_&i._MEM_ID integer;
        %if &idx_cols lt 16 & &i ^= &ord_source & &i ^= &ord_currency  %then %do;
            %if "&dim_col" = "" %then %do;
                %let dim_col=DIM_&i._MEM_ID;
            %end;
            %else %do;
                %let dim_col=&dim_col, DIM_&i._MEM_ID;
            %end;
            %let idx_cols = %eval(&idx_cols + 1);
         %end;
    %end;
%end;


/*------------------------------------------------------------------------*/
/* Decide the storage type of a temp fact table to be created in SASSDM */
/*------------------------------------------------------------------------*/
%let stg_type_tmp=myisam;

/*-----------------------------------------*/
/* Move ETL base fact from SAS into SASSDM */
/*-----------------------------------------*/
proc sql noprint;
     connect to &sesetl_EngineType as PASSTHRU ( &sesetl_BestLogin &sesetl_ConnectionOptions );

     execute (DROP TABLE IF EXISTS &cSDMFactsDB_NEW
     ) by PASSTHRU;

     execute(CREATE TABLE &cSDMFactsDB_NEW  (
               OBJECT_TYPE_ID INTEGER NOT NULL default 0,
               OBJECT_ID INTEGER NOT NULL default 0,
               &dim_col_def,
               FACT_VALUE DOUBLE PRECISION  NOT NULL default 0
             )
       ) by PASSTHRU ;

     disconnect from PASSTHRU ;
quit;
%checkErr;
%if &_tmpRC %then endsas;


/* Remove zero value records from sas fact table  */
data &cSASFactsDS_NEW;
   set &cSASFactsDS;
run;
%checkErr;
%if &_tmpRC %then endsas;

/* Transfer new sas fact table into database area */

%cpm_uploadDataToSDM(&cSASFactsDS_NEW, &cSDMFactsDB_NEW);

%if %symexist(cpmdbug) and %symexist(dbuglib) %then %do;
   %if &cpmdbug = 1 %then %do;
      data &dbuglib..result_&table_suffix;
         set &cSASFactsDS_NEW;
      run;
      %checkErr;
      %if &_tmpRC %then endsas;
   %end;
%end;

/*------------------------------------------*/
/* Decide storage type of two result tables */
/*------------------------------------------*/
%let stg_type_res=myisam;

%cpm_updateRemoveStatusCnt( &cStatusDS, &cSASFactsDS, REMOVE_CNT );

/*  Join : extracting commonly found data idx                                                         */
/*  If nActionType =              4 : Join (etl_base x sas_base  U  etl_no_base x sas_no_base)        */
/*                                5 : Join (etl_no_base x sas_no_base)  : all splitted and joined     */
/*                   other than 4,5 : Join (etl_base x etl_base)        : Nothing splitted and joined */

/* Prepare conditional statement in where clause */

/* In case comparing all dimensions : no_split */
%do i=0 %to &num_dim_type-1;
    %if (&i = 0) %then %do;
        %let where_no_split=S.DIM_&i._MEM_ID = M.DIM_&i._MEM_ID;
    %end;
    %else %do;
        %let where_no_split=&where_no_split and S.DIM_&i._MEM_ID = M.DIM_&i._MEM_ID;
    %end;
%end;

/* In case comparing all except source and currency */
%let where_split=;
%do i=0 %to &num_dim_type-1;
    %if ("&where_split" = "") %then %do;
        %if (&i = &ord_currency or &i = &ord_source) %then %do;
            %let where_split=;
        %end;
        %else %do;
            %let where_split=S.DIM_&i._MEM_ID = M.DIM_&i._MEM_ID;
        %end;
    %end;
    %else %do;
        %if (&i ^= &ord_currency and &i ^= &ord_source) %then %do;
            %let where_split=&where_split and S.DIM_&i._MEM_ID = M.DIM_&i._MEM_ID;
        %end;
    %end;
%end;

%let _tmpindex = idx_dims_%sysfunc(kcompress(%sysfunc( datetime() ), .));

proc sql noprint;
     connect to &sesetl_EngineType as PASSTHRU ( &sesetl_BestLogin &sesetl_ConnectionOptions );

     /* Create a composite index on sas etl fact table */
     execute(CREATE INDEX &_tmpindex on &cSDMFactsDB_NEW (&dim_col)
      ) by PASSTHRU ;

    disconnect from PASSTHRU ;

quit;
%checkErr;
%if &_tmpRC %then endsas;

%THEEND:

%mend cpm_replaceMatching;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_updateRemoveStatusCnt.sas                                            */
/*  Purpose: Update Valid Status Count.                                                */
/***************************************************************************************/
%macro cpm_updateRemoveStatusCnt(cStatusDS, cDS, cImpCntColNm);

  %let cMethodNm = cpm_updateRemoveStatusCnt;
  %let nowDTTM = %qsysfunc(datetime());
  %let nTrackTime = %qsysfunc(datetime());

  %let _nobs = 0;
  data _null_;
    set &cDS nobs=_nobs;
    call symput('_nobs', _nobs);
    stop;
  run;
  %checkErr;
  %if &_tmpRC %then endsas;

  proc sql noprint;
    update &cStatusDS
    set &cImpCntColNm = &cImpCntColNm +
       case when status_id ne 0
         then 0
         else &_nobs
       end
    ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

%mend cpm_updateRemoveStatusCnt;

/***************************************************************************************/
/* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.       */
/*  Name   : cpm_uploadStatusTableToSDM.sas                                           */
/*  Purpose: Upload Status Table to SDM.                                               */
/***************************************************************************************/
%macro cpm_uploadStatusTableToSDM( cSrcTable, cTrgTable);

  %let cMethodNm = cpm_uploadStatusTable;
  %let nowDTTM = %qsysfunc(datetime());
  %let nTrackTime = %qsysfunc(datetime());

  %let tmpUploadNm = PUBLIC.%kscan(&cTrgTable, 2);

  proc sql noprint;
    connect to &sesetl_EngineType ( &sesetl_BestLogin &sesetl_ConnectionOptions );

   execute(CREATE TABLE &tmpUploadNm (
              TIME_ID INTEGER,
              ANALYSIS_ID INTEGER,
              PERIOD_ID INTEGER,
              STATUS_ID INTEGER,
              IMPORTED_TRANS_CNT INTEGER,
              ZERO_TRANS_CNT INTEGER,
              INVALID_ERROR_CNT INTEGER,
              REMOVE_CNT INTEGER
            )
      ) by &sesetl_EngineType ;


    disconnect from &sesetl_EngineType ;
  quit;
  %checkErr;
  %if &_tmpRC %then endsas;

  %cpm_uploadDataToSDM(&cSrcTable, &tmpUploadNm);

%mend cpm_uploadStatusTableToSDM;

/***************************************************************************************/
